diff --git a/drivers/infiniband/hw/cxgb4/provider.c b/drivers/infiniband/hw/cxgb4/provider.c
index cbb3c0ddd990..604cc03e105a 100644
--- a/drivers/infiniband/hw/cxgb4/provider.c
+++ b/drivers/infiniband/hw/cxgb4/provider.c
@@ -531,6 +531,56 @@ static int fill_res_entry(struct sk_buff *msg, struct rdma_restrack_entry *res)
 		c4iw_restrack_funcs[res->type](msg, res) : 0;
 }
 
+static const struct ib_device_ops c4iw_dev_ops = {
+	/* Device operations */
+	.query_device = c4iw_query_device,
+	.get_dev_fw_str = get_dev_fw_str,
+	/* Port operations */
+	.query_port = c4iw_query_port,
+	.get_port_immutable = c4iw_port_immutable,
+	.get_netdev = get_netdev,
+	/* PKey operations */
+	.query_pkey = c4iw_query_pkey,
+	/* GID operations */
+	.query_gid = c4iw_query_gid,
+	/* Ucontext operations */
+	.alloc_ucontext = c4iw_alloc_ucontext,
+	.dealloc_ucontext = c4iw_dealloc_ucontext,
+	.mmap = c4iw_mmap,
+	/* PD operations */
+	.alloc_pd = c4iw_allocate_pd,
+	.dealloc_pd = c4iw_deallocate_pd,
+	/* QP operations */
+	.create_qp = c4iw_create_qp,
+	.modify_qp = c4iw_ib_modify_qp,
+	.query_qp = c4iw_ib_query_qp,
+	.destroy_qp = c4iw_destroy_qp,
+	.post_send = c4iw_post_send,
+	.post_recv = c4iw_post_receive,
+	/* SRQ operations */
+	.create_srq = c4iw_create_srq,
+	.modify_srq = c4iw_modify_srq,
+	.destroy_srq = c4iw_destroy_srq,
+	.post_srq_recv = c4iw_post_srq_recv,
+	/* CQ operations */
+	.create_cq = c4iw_create_cq,
+	.destroy_cq = c4iw_destroy_cq,
+	.poll_cq = c4iw_poll_cq,
+	.req_notify_cq = c4iw_arm_cq,
+	/* MR operations */
+	.get_dma_mr = c4iw_get_dma_mr,
+	.reg_user_mr = c4iw_reg_user_mr,
+	.dereg_mr = c4iw_dereg_mr,
+	.alloc_mr = c4iw_alloc_mr,
+	.map_mr_sg = c4iw_map_mr_sg,
+	/* MW operations */
+	.alloc_mw = c4iw_alloc_mw,
+	.dealloc_mw = c4iw_dealloc_mw,
+	/* Stats operations */
+	.alloc_hw_stats = c4iw_alloc_stats,
+	.get_hw_stats = c4iw_get_mib,
+};
+
 void c4iw_register_device(struct work_struct *work)
 {
 	int ret;
@@ -573,42 +623,7 @@ void c4iw_register_device(struct work_struct *work)
 	dev->ibdev.phys_port_cnt = dev->rdev.lldi.nports;
 	dev->ibdev.num_comp_vectors =  dev->rdev.lldi.nciq;
 	dev->ibdev.dev.parent = &dev->rdev.lldi.pdev->dev;
-	dev->ibdev.query_device = c4iw_query_device;
-	dev->ibdev.query_port = c4iw_query_port;
-	dev->ibdev.query_pkey = c4iw_query_pkey;
-	dev->ibdev.query_gid = c4iw_query_gid;
-	dev->ibdev.alloc_ucontext = c4iw_alloc_ucontext;
-	dev->ibdev.dealloc_ucontext = c4iw_dealloc_ucontext;
-	dev->ibdev.mmap = c4iw_mmap;
-	dev->ibdev.alloc_pd = c4iw_allocate_pd;
-	dev->ibdev.dealloc_pd = c4iw_deallocate_pd;
-	dev->ibdev.create_qp = c4iw_create_qp;
-	dev->ibdev.modify_qp = c4iw_ib_modify_qp;
-	dev->ibdev.query_qp = c4iw_ib_query_qp;
-	dev->ibdev.destroy_qp = c4iw_destroy_qp;
-	dev->ibdev.create_srq = c4iw_create_srq;
-	dev->ibdev.modify_srq = c4iw_modify_srq;
-	dev->ibdev.destroy_srq = c4iw_destroy_srq;
-	dev->ibdev.create_cq = c4iw_create_cq;
-	dev->ibdev.destroy_cq = c4iw_destroy_cq;
-	dev->ibdev.poll_cq = c4iw_poll_cq;
-	dev->ibdev.get_dma_mr = c4iw_get_dma_mr;
-	dev->ibdev.reg_user_mr = c4iw_reg_user_mr;
-	dev->ibdev.dereg_mr = c4iw_dereg_mr;
-	dev->ibdev.alloc_mw = c4iw_alloc_mw;
-	dev->ibdev.dealloc_mw = c4iw_dealloc_mw;
-	dev->ibdev.alloc_mr = c4iw_alloc_mr;
-	dev->ibdev.map_mr_sg = c4iw_map_mr_sg;
-	dev->ibdev.req_notify_cq = c4iw_arm_cq;
-	dev->ibdev.post_send = c4iw_post_send;
-	dev->ibdev.post_recv = c4iw_post_receive;
-	dev->ibdev.post_srq_recv = c4iw_post_srq_recv;
-	dev->ibdev.alloc_hw_stats = c4iw_alloc_stats;
-	dev->ibdev.get_hw_stats = c4iw_get_mib;
 	dev->ibdev.uverbs_abi_ver = C4IW_UVERBS_ABI_VERSION;
-	dev->ibdev.get_port_immutable = c4iw_port_immutable;
-	dev->ibdev.get_dev_fw_str = get_dev_fw_str;
-	dev->ibdev.get_netdev = get_netdev;
 
 	dev->ibdev.iwcm = kmalloc(sizeof(struct iw_cm_verbs), GFP_KERNEL);
 	if (!dev->ibdev.iwcm) {
@@ -630,6 +645,7 @@ void c4iw_register_device(struct work_struct *work)
 
 	rdma_set_device_sysfs_group(&dev->ibdev, &c4iw_attr_group);
 	dev->ibdev.driver_id = RDMA_DRIVER_CXGB4;
+	ib_set_device_ops(&dev->ibdev, &c4iw_dev_ops);
 	ret = ib_register_device(&dev->ibdev, "cxgb4_%d", NULL);
 	if (ret)
 		goto err_kfree_iwcm;